
var SliderVariables = new Object();

function InitSlider (slidername, width, height, itemcount) 
{
    if (SliderVariables[slidername] == undefined) {
        SliderVariables[slidername] = new Object();
    }
    SliderVariables[slidername]['width'] = width;
    SliderVariables[slidername]['height'] = height;
    SliderVariables[slidername]['itemcount'] = itemcount;
    SliderVariables[slidername]['currentitem'] = -1 + Math.floor(Math.random()*itemcount);
    //SliderMoveToItem (0, slidername);
    SliderVariables[slidername]['autoshow'] = true;
    SliderVariables[slidername]['autochangekilled'] = false;
    SliderAutoChange (slidername);
}

function SliderAutoChange (slidername) {
    if (SliderVariables[slidername]['autoshow']) {
        SliderMoveToItem(SliderVariables[slidername]['currentitem']+1, slidername);
        SliderVariables[slidername]['autochangekilled'] = false;
        setTimeout(function(){ SliderAutoChange(slidername); }, 10000);
    }
    else
        SliderVariables[slidername]['autochangekilled'] = true;
}

function SliderPauseAutoshow (slidername) {
    SliderVariables[slidername]['autoshow'] = false;
}

function SliderResumeAutoshow (slidername) {
    SliderVariables[slidername]['autoshow'] = true;
    if (SliderVariables[slidername]['autochangekilled']) {
        SliderVariables[slidername]['autochangekilled'] = false;
        setTimeout(function(){ SliderAutoChange(slidername); }, 2000);
    }
}

//-------------------------------------

function SliderMoveToItem (itemNo, slidername)
{
    itemNo = itemNo % SliderVariables[slidername]['itemcount'];
    SliderMoveToPixelPos( itemNo*SliderVariables[slidername]['height'], slidername );
    SliderVariables[slidername]['currentitem'] = itemNo;
    
    var lis = document.getElementById(slidername).getElementsByTagName('ul')[1].getElementsByTagName('li');
    for (var i=0; i<lis.length; i++) {
        if (i==itemNo)
            lis[i].setAttribute("class", "current");
        else
            lis[i].setAttribute("class", "");
    }
}

//-------------------------------------

function SliderMoveToPixelPos (pixelpos, slidername, speed) 
{
    if (SliderVariables[slidername] == undefined) {
        SliderVariables[slidername] = new Object();
    }

    var currentpos = parseInt(document.getElementById(slidername).getElementsByTagName('ul')[0].style.top);
    if (isNaN(currentpos)) currentpos = 0;
    
    if (currentpos!=-pixelpos)
    {
        var diff = (-currentpos) - pixelpos;
        
        if (speed==undefined) {
            var speed =  new Object();
            speed['interval'] = 40;
            SliderVariables[slidername]['lastrequestedpixelpos'] = pixelpos;
        }
        speed['size'] = Math.ceil( Math.abs(diff) / 5 );
        
        if (Math.abs(diff) <= speed['size'])
            var step = diff;
        else
            var step = ( (diff>0)?1:-1 ) * speed['size'];
        document.getElementById(slidername).getElementsByTagName('ul')[0].style.top = (currentpos+step)+'px';
        
        if (pixelpos == SliderVariables[slidername]['lastrequestedpixelpos'])
            setTimeout( function(){SliderMoveToPixelPos(pixelpos, slidername, speed);}, speed['interval'] );
    }
}


